import { system, world} from "@minecraft/server";

world.afterEvents.itemUse.subscribe(eventData => {
    const player = eventData.source;
	const useItemId = eventData.itemStack.typeId;
	if (useItemId == "rioto:blade") {
        if (player.hasTag="rittai_ok") {
            player.runCommand("function slash")
        }
    }
});

system.afterEvents.scriptEventReceive.subscribe(ev => {
    if (ev.id === "rioto:rittai") {
        if (ev.sourceEntity.getEffect("slow_falling")) {
            const muki = ev.sourceEntity.getViewDirection();
            ev.sourceEntity.applyKnockback(muki.x,muki.z, 4, muki.y+1.5);
        }else{
            const muki = ev.sourceEntity.getViewDirection();
            ev.sourceEntity.applyKnockback(muki.x,muki.z, 4, muki.y+0.4);
        }
    }
});

system.afterEvents.scriptEventReceive.subscribe(ev => {
    if (ev.id === "rioto:hook") {
        const [entity] = world.getDimension("overworld").getEntities({ type:"rioto:hook" })
        const leashable = entity.getComponent("leashable")
            leashable.leashTo(ev.sourceEntity);
    }
});

world.afterEvents.playerInteractWithEntity.subscribe(ev => {
    if (ev.target.typeId === "rioto:rittai_kunren")
    ev.player.runCommand('function rittai_kunren');
  });